Package org.codehaus.groovy.tools

# Class FileSystemCompiler

java.lang.Object
org.codehaus.groovy.tools.FileSystemCompiler

public class FileSystemCompiler extends Object
Command-line compiler (aka. `groovyc`).

## Constructor Summary

Constructors
Constructor
Description
`FileSystemCompiler(CompilerConfiguration configuration)`
`FileSystemCompiler(CompilerConfiguration configuration, CompilationUnit cu)`

## Method Summary

Modifier and Type
Method
Description
`static int`
`checkFiles(String[] filenames)`
`static void`
`commandLineCompile(String[] args)`
Same as main(args) except that exceptions are thrown out instead of causing the VM to exit.
`static void`
`commandLineCompile(String[] args, boolean lookupUnnamedFiles)`
Same as main(args) except that exceptions are thrown out instead of causing the VM to exit and the lookup for .groovy files can be controlled
`static void`
`commandLineCompileWithErrorHandling(String[] args, boolean lookupUnnamedFiles)`
Primary entry point for compiling from the command line (using the groovyc script).
`void`
`compile(File[] files)`
`void`
`compile(String[] paths)`
`static org.apache.commons.cli.Options`
`createCompilationOptions()`
`static File`
`createTempDir()`
Deprecated.
Use `DefaultGroovyStaticMethods.createTempDir(java.io.File, String, String)` instead.
`static void`
`deleteRecursive(File file)`
`static void`
`displayHelp(org.apache.commons.cli.Options options)`
`static void`
`displayVersion()`
`static void`
`doCompilation(CompilerConfiguration configuration, CompilationUnit unit, String[] filenames)`
`static void`
`doCompilation(CompilerConfiguration configuration, CompilationUnit unit, String[] filenames, boolean lookupUnnamedFiles)`
`static CompilerConfiguration`
`generateCompilerConfigurationFromOptions(org.apache.commons.cli.CommandLine cli)`
`static String[]`
`generateFileNamesFromOptions(org.apache.commons.cli.CommandLine cli)`
`static void`
`main(String[] args)`
Primary entry point for compiling from the command line (using the groovyc script).
`static boolean`
`validateFiles(String[] filenames)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### FileSystemCompiler

public FileSystemCompiler(CompilerConfiguration configuration) throws ConfigurationException

Throws:
  `ConfigurationException`

### FileSystemCompiler

public FileSystemCompiler(CompilerConfiguration configuration, CompilationUnit cu) throws ConfigurationException

Throws:
  `ConfigurationException`

## Method Details

### compile

public void compile(String[] paths) throws Exception

Throws:
  `Exception`

### compile

public void compile(File[] files) throws Exception

Throws:
  `Exception`

### displayHelp

public static void displayHelp(org.apache.commons.cli.Options options)

### displayVersion

public static void displayVersion()

### checkFiles

public static int checkFiles(String[] filenames)

### validateFiles

public static boolean validateFiles(String[] filenames)

### commandLineCompile

public static void commandLineCompile(String[] args) throws Exception
Same as main(args) except that exceptions are thrown out instead of causing the VM to exit.

Throws:
  `Exception`

### commandLineCompile

public static void commandLineCompile(String[] args, boolean lookupUnnamedFiles) throws Exception
Same as main(args) except that exceptions are thrown out instead of causing the VM to exit and the lookup for .groovy files can be controlled

Throws:
  `Exception`

### main

public static void main(String[] args)
Primary entry point for compiling from the command line (using the groovyc script).

If calling inside a process and you don't want the JVM to exit on an error call commandLineCompile(String[]), which this method simply wraps

Parameters:
  `args` - command line arguments

### commandLineCompileWithErrorHandling

public static void commandLineCompileWithErrorHandling(String[] args, boolean lookupUnnamedFiles)
Primary entry point for compiling from the command line (using the groovyc script).

If calling inside a process and you don't want the JVM to exit on an error call commandLineCompile(String[]), which this method simply wraps

Parameters:
  `args` - command line arguments
  `lookupUnnamedFiles` - do a lookup for .groovy files not part of the given list of files to compile

### doCompilation

public static void doCompilation(CompilerConfiguration configuration, CompilationUnit unit, String[] filenames) throws Exception

Throws:
  `Exception`

### doCompilation

public static void doCompilation(CompilerConfiguration configuration, CompilationUnit unit, String[] filenames, boolean lookupUnnamedFiles) throws Exception

Throws:
  `Exception`

### generateFileNamesFromOptions

public static String[] generateFileNamesFromOptions(org.apache.commons.cli.CommandLine cli)

### generateCompilerConfigurationFromOptions

public static CompilerConfiguration generateCompilerConfigurationFromOptions(org.apache.commons.cli.CommandLine cli) throws IOException

Throws:
  `IOException`

### createCompilationOptions

public static org.apache.commons.cli.Options createCompilationOptions()

### createTempDir

@Deprecated public static File createTempDir() throws IOException
Deprecated.
Use `DefaultGroovyStaticMethods.createTempDir(java.io.File, String, String)` instead.
Creates a temporary directory in the default temporary directory (as specified by the system property java.io.tmpdir.

Throws:
  `IOException`

### deleteRecursive

public static void deleteRecursive(File file)